package internal

import (
	"io"
	"io/ioutil"
	goLog "log"
	"os"

	logkit "gitlab.com/gitlab-org/labkit/log"
)

func SetupLog(file string, format string, level string) (io.Closer, error) {
	// Golog always goes to stderr
	goLog.SetOutput(os.Stderr)

	if level == "quiet" {
		return logkit.Initialize(logkit.WithWriter(ioutil.Discard))
	}

	return logkit.Initialize(
		logkit.WithOutputName(file),
		logkit.WithFormatter(format),
		logkit.WithLogLevel(level),
	)
}
